Page MenuHomePhabricator

Fatal from ApiHelpPanelPostQuestion: Argument to QuestionPoster::runEditFilterMergedContentHook must implement Content
Closed, ResolvedPublic

Description

Error

Request URL: POST testwiki /w/api.php
Request ID: XQul7ApAMDkAAKFM-pgAAAAP

message
PHP Fatal Error from line 176 of /srv/mediawiki/php-1.34.0-wmf.10/extensions/GrowthExperiments/includes/HelpPanel/QuestionPoster.php: Argument 1 passed to GrowthExperiments\HelpPanel\QuestionPoster::runEditFilterMergedContentHook() must implement interface Content, null given
trace
#0 /srv/mediawiki/php-1.34.0-wmf.10/extensions/GrowthExperiments/includes/HelpPanel/QuestionPoster.php(176): NO_FUNCTION_GIVEN()
#1 /srv/mediawiki/php-1.34.0-wmf.10/extensions/GrowthExperiments/includes/HelpPanel/QuestionPoster.php(117): GrowthExperiments\HelpPanel\QuestionPoster->checkPermissions()
#2 /srv/mediawiki/php-1.34.0-wmf.10/extensions/GrowthExperiments/includes/Api/ApiHelpPanelPostQuestion.php(70): GrowthExperiments\HelpPanel\QuestionPoster->submit()
#3 /srv/mediawiki/php-1.34.0-wmf.10/includes/api/ApiMain.php(1595): GrowthExperiments\Api\ApiHelpPanelPostQuestion->execute()
#4 /srv/mediawiki/php-1.34.0-wmf.10/includes/api/ApiMain.php(531): ApiMain->executeAction()
#5 /srv/mediawiki/php-1.34.0-wmf.10/includes/api/ApiMain.php(502): ApiMain->executeActionWithErrorHandling()
#6 /srv/mediawiki/php-1.34.0-wmf.10/api.php(87): ApiMain->execute()
#7 /srv/mediawiki/w/api.php(3): include(string)
#8 {main}

Impact

The request was aborted and served HTTP 500 response. It is likely deterministic and would mean feature is not available to users. Frequency according to Logstash: 29 occurrences in 2 minutes.

Notes

Started with 1.34-wmf.10 (currently group0 only).

Details

Related Gerrit Patches:
mediawiki/extensions/GrowthExperiments : masterQuestion Poster: Refactor to prevent fatals on permissions check

Event Timeline

Krinkle created this task.Jun 20 2019, 4:36 PM
Restricted Application added a project: Growth-Team. · View Herald TranscriptJun 20 2019, 4:36 PM
Restricted Application added a subscriber: Aklapper. · View Herald Transcript
kostajh claimed this task.Jun 20 2019, 4:39 PM
kostajh edited projects, added Growth-Team (Current Sprint); removed Growth-Team.
kostajh moved this task from Incoming to In Progress on the Growth-Team (Current Sprint) board.
Catrope updated the task description. (Show Details)Jun 21 2019, 12:19 AM

Change 518739 had a related patch set uploaded (by Kosta Harlan; owner: Kosta Harlan):
[mediawiki/extensions/GrowthExperiments@master] Question Poster: Refactor to prevent fatals on permissions check

https://gerrit.wikimedia.org/r/518739

IMO this is not a blocker for wmf.11 or wmf.10. We are working on a patch so that if pageUpdater->grabParentRevision->getContent() doesn't return a Content object, we won't fail as hard.

greg added a subscriber: greg.Jun 24 2019, 5:06 PM

IMO this is not a blocker for wmf.11 or wmf.10. We are working on a patch so that if pageUpdater->grabParentRevision->getContent() doesn't return a Content object, we won't fail as hard.

Can you say more why it's not a blocker?

If this is really not a blocker then lets remove the parent tasks. @kostajh: can you explain? Also, what remains to be done with https://gerrit.wikimedia.org/r/518739 before it can merge? I'd like to deploy wmf.10 today but I would prefer to fix the fatals before doing so.

kostajh added a subscriber: Cntlsn.Jun 24 2019, 5:10 PM

Can you say more why it's not a blocker?

@greg the problem, AFAIK, occurred in a single session for one user (@Cntlsn) while debugging some UI issues on testwiki. While investigating, I noticed that posting a question via the help panel (the user flow which triggered the fatal errors) took 16 seconds. My suspicion is that something was up with testwiki infrastructure during the period of time when @Cntlsn was testing.

Yes, the code is too brittle and is being adjusted in the patch linked to this task, but no, I don't think we would be likely to see more of these in the select wikis (ko, vi, cs) where the help panel is deployed when wmf 10 / wmf 11 reach group 2.

Thanks @kostajh, indeed that sounds like it's not a blocker.

Change 518739 merged by jenkins-bot:
[mediawiki/extensions/GrowthExperiments@master] Question Poster: Refactor to prevent fatals on permissions check

https://gerrit.wikimedia.org/r/518739

Etonkovidova closed this task as Resolved.Jul 11 2019, 9:08 PM
Etonkovidova added a subscriber: Etonkovidova.

Checked logstash in wmf.13 - no errors.

mmodell changed the subtype of this task from "Task" to "Production Error".Aug 28 2019, 11:06 PM